package com.link.core.util.json;

import com.fasterxml.jackson.annotation.JsonInclude.Include;
import com.fasterxml.jackson.core.JsonParser.Feature;
import com.fasterxml.jackson.databind.DeserializationFeature;
import com.fasterxml.jackson.databind.ObjectMapper;
import java.io.IOException;
import java.util.Map;

public class JackJsonUtils {
   public static String obj2JsonStr(JacksonJsonFilter jacksonFilter, Object obj) throws IOException {
      ObjectMapper objectMapperObj = new ObjectMapper();
      if (!jacksonFilter.replaceMap.isEmpty()) {
         if (!(obj instanceof Map)) {
            obj = objectMapperObj.readValue(objectMapperObj.writeValueAsString(obj), Map.class);
         } else {
            obj = (Map)obj;
         }
      }

      ObjectMapper objectMapper = new ObjectMapper();
      objectMapper.configure(DeserializationFeature.FAIL_ON_UNKNOWN_PROPERTIES, false);
      objectMapper.configure(Feature.ALLOW_UNQUOTED_CONTROL_CHARS, true);
      objectMapper.configure(Feature.ALLOW_BACKSLASH_ESCAPING_ANY_CHARACTER, true);
      objectMapper.configure(Feature.ALLOW_SINGLE_QUOTES, true);
      objectMapper.addMixIn(Object.class, JacksonJsonFilter.class);
      objectMapper.setFilterProvider(jacksonFilter);
      return objectMapper.writeValueAsString(obj);
   }

   public static String obj2JsonStr(Object obj) throws IOException {
      ObjectMapper objectMapper = new ObjectMapper();
      objectMapper.configure(DeserializationFeature.FAIL_ON_UNKNOWN_PROPERTIES, false);
      objectMapper.configure(Feature.ALLOW_UNQUOTED_CONTROL_CHARS, true);
      objectMapper.configure(Feature.ALLOW_BACKSLASH_ESCAPING_ANY_CHARACTER, true);
      objectMapper.configure(Feature.ALLOW_SINGLE_QUOTES, true);
      objectMapper.setSerializationInclusion(Include.NON_EMPTY);
      objectMapper.addMixIn(Object.class, JacksonJsonFilter.class);
      objectMapper.setFilterProvider(new JacksonJsonFilter());
      return objectMapper.writeValueAsString(obj);
   }

   public static <T> T str2Obj(String str, Class<T> cls) throws IOException {
      ObjectMapper objectMapper = new ObjectMapper();
      objectMapper.configure(DeserializationFeature.FAIL_ON_UNKNOWN_PROPERTIES, false);
      objectMapper.configure(Feature.ALLOW_UNQUOTED_CONTROL_CHARS, true);
      objectMapper.configure(Feature.ALLOW_BACKSLASH_ESCAPING_ANY_CHARACTER, true);
      objectMapper.configure(Feature.ALLOW_SINGLE_QUOTES, true);
      objectMapper.setSerializationInclusion(Include.NON_EMPTY);
      T aClass = objectMapper.readValue(str, cls);
      return aClass;
   }
}
